;paulfjujo 22 fec 2013
; test on LM35DZ

		list p=18f252		
		#include <p18f252_.inc>	;processor specific definitions
		
	CONFIG OSC=HS  ,OSCS=OFF
	CONFIG BOR=OFF
	CONFIG WDT=OFF ,CCP2MUX=OFF
	CONFIG STVR=OFF, LVP=OFF, DEBUG=OFF
	CONFIG CPB=OFF	; boot protect off
	CONFIG CP0=OFF,CP1=OFF,CP2=OFF,CP3=OFF
	CONFIG CPD=OFF

;----  select here Quartz & Baud rate RS232 ------------------------

#define FOSC D'10000000'	; quartz 10MHZ
#define BAUD D'19200'
#define DIVIDER (FOSC/(D'16' * BAUD))-1

;#define FOSC D'4000000'	; quartz 4MHZ
;#define BAUD D'19200'
;#define DIVIDER (FOSC/(D'16' * BAUD))-1

;#define FOSC D'2000000'	; quartz 2MHZ
;#define BAUD D'19200'
;#define DIVIDER (FOSC/(D'16' * BAUD))-1

;#define TESTING

;----------------------------------------------------------------------------
;Bit Definitions


LCD_DATA EQU PORTB
CTRL    EQU TRISA
RS EQU RC0
RW EQU RA2
EN EQU RC1
ADC EQU RA0
CI EQU RA4
HT EQU RA5
FN EQU RA6

;----------------------------------------------------------------------------
;Variables

		CBLOCK	0x000
		Tm1
	    PL
        PH 
        Q1L
        Q1H
        Q2 
        Q3 
        Count
        NbMesures
        Drapeaux	; multipurpose flags
;Drapeau:7= signe mesure temp 1=negatif 0=positif pour DS1624
;Drapeau:6= Elligibilite de stockage mesure
;Drapeau:5 =test si saisie binaire ou BCD
;Drapeau:4= choix format 1=999   0=65535 pour bcd53 (5 ou 3 digits)
;Drapeau:3= choix format 1=XX    0=XXX pour bcd3
;Drapeau:2= choix output 1=Rs232 0=LCD
;Drapeau:1= choix format 1=XXXX.X  0=XXXXX pour bcd5
;Drapeau:0= pour effacer zero inutile

; Bcd
    Mcount
	btmp
	btmp1
	dixmil	
	mille
	cent
	dix
	uno
	value		
; variables 16 bits
 	MesAn0	    :2	
	valx        :2
	val1		:2			; val1=LOW  Val1+1=HIGH
	val2		:2
	Cumul		:2
	reste		:2
	result	    :2
	ENDC

	ORG     0x0000		;place code at reset vector
	nop
	nop
	goto    Main	

;----------------------------------------------------------------------------
;This code executes when a high priority interrupt occurs.

		ORG	0x0008		;place code at interrupt vector

HiIntCode:	;do interrupts here

		reset			;error if no valid interrupt so reset

;----------------------------------------------------------------------------
;This code executes when a low priority interrupt occurs.

		ORG	0x0018		;place code at interrupt vector

LoIntCode:	;do interrupts here

		reset			;error if no valid interrupt so reset

;----------------------------------------------------------------------------

Main:

    clrf Drapeaux
    ;init serial RS232 @ 19200bds Q=10MHz
    bsf TRISC,RC7	
    bcf TRISC,RC6
	movlw	DIVIDER 	;set baud rate 
	movwf	SPBRG
;	Q= 10MHZ  19200 bauds
	movlw	0x24		;enable transmission TXEN=1 and BRGH=1 high baud rate
;	Q=4MHZ 4800 bauds
;   movlw 0x20
	movwf	TXSTA
	bank0
	movlw	0x90		;enable serial port SPEN=1 and reception CREN=1
	movwf	RCSTA
;    
    MOVLW .12       ; CLS
    call Rs_Putchar  
    call SEC_DLY
  
;    
    MOVLW 'S'
    call Rs_Putchar
    MOVLW 'T'
    call Rs_Putchar
    MOVLW 'A'
    call Rs_Putchar
    MOVLW 'R'
    call Rs_Putchar
    MOVLW 'T'
    call Rs_Putchar
    MOVLW .10
    call Rs_Putchar
    MOVLW .13
    call Rs_Putchar
;    
    MOVLW b'00010001' ; RA0 et RA4 as input others outputs
    MOVWF TRISA
    CLRF TRISC
    CLRF TRISB
 
 	;CONFIGURE Timer0 as COUNTER 
    BSF PORTA,4     ; RA4 as input
    MOVLW 28H	    ;No prescaler,Transition on T0CKI pin, low edge ,COUNTER, 16BIT
    MOVWF T0CON
    BCF INTCON,TMR0IF
    BCF INTCON,INT0IE
;
;TIMER1,16 BIT, INT-CLK, PRESCALER 1:8	
; 0xB0h  mode 2x8bits, innternal clock Fosc/4 prescaler=1/8, TRM1 OFF
	MOVLW b'00110000' 	 
    MOVWF T1CON
    BCF PIR1,TMR1IF
    BCF PIE1,TMR1IE ; NO interrupt
    BSF IPR1,TMR1IP ; hig priority interrup (if used!)
    MOVLW  0x0B
    MOVWF TMR1H
    MOVLW  0xDB
    MOVWF TMR1L
    BCF T1CON,TMR1ON ; timer1 OFF  , not yet used
;
;ADC CONFIGURE RA0=An0  others as digital 
    BSF CTRL,ADC
    MOVLW b'01000001' ; Fosc/16 channel 0  AD ON
    MOVWF ADCON0
    MOVLW b'10001110'  ; Right justified,Fosc/16,RA0 Analog, other digital +Vref=VDD -Vref=Gnd 
    MOVWF ADCON1
;
   movlw .10
   movwf  NbMesures
   clrf Cumul
   clrf Cumul+1
;
MainLoop

;PROCESSING TEMP
  BSF ADCON0,GO
  call DELAY
        
BACKADC:
 
 ifdef TESTING
   ; simule ADC0 = 0039
    movlw .40
    movwf val1
    clrf val1+1
  else
   	BTFSC ADCON0,DONE
	BRA BACKADC
	NOP
	MOVF ADRESL,W
	movwf val1       ; prepare for convert
	MOVF ADRESH,W
	movwf val1+1
 Endif  
	bcf Drapeaux,5  ; mode 5 digits   to see 00000 up to 01023
	call bcd_temp 
	MOVLW .9            ;  Tabulation
    call Rs_Putchar
    ; moyennage pour augmenter la resolution
    bcf    STATUS,C
  	movf   val1+1,W		; addition 16 bits
	addwf  Cumul+1,f	; cumul = cumul + valx
	movf   val1,W
	addwf  Cumul,f
	btfsc  STATUS, C
	incf   Cumul+1,f
	decfsz  NbMesures
 ifdef TESTING
	goto MainLoop
	else
    goto NotYet
 endif   
	movf Cumul,W    
	movwf val1      
	movf Cumul+1,W
	movwf val1+1
	bcf Drapeaux,5 ; mode XXXX
	call bcd_temp 

; divide by 2 !!
    bcf    STATUS,C
    rrcf val1+1,f     ; rotate right through carry
	rrcf val1,f

; cumul = (somme de 10 raw data) /2
	; car 1023 points pour 500C arrondi a 1000*10/2
	bsf Drapeaux,5,0  ; mode xxx.XX
	call bcd_temp 
	clrf Cumul
	clrf Cumul+1
	movlw .10
    movwf  NbMesures
	MOVLW .10
    call Rs_Putchar
    MOVLW .13
    call Rs_Putchar
    
NotYet
  ; ifdef TESTING
  ;   call DELAY
  ;   else
	CALL SEC_DLY        ; one second delay (without interrupt)
;	endif
    goto	MainLoop	;go do main loop again
 	
		
;======================== subroutines =================
		
DELAY:
    MOVLW 1FH
    MOVWF Tm1
AGAIN:
    NOP
    NOP
    DECF Tm1,f
    BNZ AGAIN
    return

LDELAY:
    MOVLW 5FH
    MOVWF Tm1
AGAIN1:
    NOP
    NOP
    DECF Tm1,f
    BNZ AGAIN1
    return
    
    
; one second delay f(Quartz)
SEC_DLY  
    bank0
    IF FOSC == .10000000
	MOVLW 5                 ; 5 x 200mS Q=10MHz
	ENDIF
	IF FOSC == .4000000
	MOVLW 2                 ; 2 x 500mS Q=4MHz
    ENDIF
   	IF FOSC == .2000000
	MOVLW 1                 ; 1 x 1000mS Q=4MHz
    ENDIF
    MOVWF Count,0
T0:  
    MOVLW LOW (.3035)  ; DBh
    MOVWF TMR1L
    MOVLW HIGH (.3035)  ;  0Bh
    MOVWF TMR1H
    BCF PIR1,TMR1IF 
    BSF T1CON,TMR1ON	;START TIMER1
T1:
    BTFSS PIR1, TMR1IF
    BRA T1
    BCF T1CON,TMR1ON    ;SToP TIMER1
    DECF Count,f,0
    BNZ T0
    BCF PIR1,TMR1IF 
    BCF T1CON,TMR1ON	;STOP TIMER
    return		
		
		

;---------------- Binary (16-bit) to BCD -----------------------
; 16-bit-Binary  ->  4 digits de 8bits
; ( val1:val1+1) ->  Dixmil , mille , cent , dix , uno 
bcd_temp 
; save value 
        movf val1,W
        movwf valx
        movf val1+1,W
        movwf valx+1
        swapf   val1+1,W 	; HIGH
        andlw   0x0F
        addlw   0xF0
        movwf   mille
        addwf   mille,F
        addlw   0xE2 
        movwf   cent 
        addlw   0x32 
        movwf   uno 
        movf    val1+1,W 
        andlw   0x0F 
        addwf   cent,F 
        addwf   cent,F
        addwf   uno,F 
        addlw   0xE9 
        movwf   dix
        addwf   dix,F
        addwf   dix,F 
        swapf   val1,W 		; LOW
        andlw   0x0F 
        addwf   dix,F 
        addwf   uno,F
        rlcf     dix,F 
        rlcf     uno,F 
        comf    uno,F 
        rlcf     uno,F 
        movf    val1,W 
        andlw   0x0F 
        addwf   uno,F 
        rlcf     mille,F
        movlw   0x07 
        movwf   dixmil
        movlw   0x0A             
Lb1: 
        decf    dix,F 
        addwf   uno,F 
        btfss   STATUS,C 
        bra   Lb1 
Lb2: 
        decf    cent,F
        addwf   dix,F 
        btfss   STATUS,C 
        bra   Lb2 
Lb3: 
        decf    mille,F 
        addwf   cent,F 
        btfss   STATUS,C
        bra   Lb3 
Lb4: 
        decf    dixmil,F 
        addwf   mille,F 
        btfss   STATUS,C 
        bra   Lb4 

	btfss Drapeaux,5    ; 1 => affichage 00000 a 999999
	bra  Bcd_5digits   ; 0 => affichage + ou - XXX.XX

	movlw '+'
	btfsc Drapeaux,7
	movlw '-'
	call Rs_Putchar

	movf   mille,w
	btfss STATUS,Z     ; si digit=0 remplace par Blanc
	bra Lb5

	movlw ' '
	call Rs_Putchar
	bra Lb6
Lb5  
	addlw  '0'
	call Rs_Putchar
Lb6
	movf   cent,w
	addlw  '0'

	call Rs_Putchar
	movf   dix,w
	addlw  '0'
		call Rs_Putchar
	movlw '.'
	call Rs_Putchar
	movf   uno,w
	addlw  '0'
	call Rs_Putchar
	movlw ''
	call Rs_Putchar
	movlw 'C'
	call Rs_Putchar
	
	bra Bcd_51
	

;---------------
Bcd_5digits
;	movf   dixmil,w
;	addlw  '0'
;	call Rs_Putchar
;	bank1
	movf   mille,w
	addlw  '0'
	call Rs_Putchar
	movf   cent,w
	addlw  '0'
	call Rs_Putchar
	movf   dix,w
	addlw  '0'
	call Rs_Putchar 
	movf   uno,w
	addlw  '0'
	call Rs_Putchar
	movlw	' '
	call Rs_Putchar
Bcd_51
; restitue val1
    movf valx,W
    movwf val1
    movf valx+1,W
    movwf val1+1
   	return

Rs_Putchar
; put your routine to display char on LCD
; after writing the car, the position on LCD must be increased
; use your code instead of this code
   		btfss	PIR1,TXIF	
   		goto Rs_Putchar
		movwf TXREG	;data transmit
		return
		
;16 bit subtraction with borrow   Rudy Wieser
sub16
	movf    val2,W		; source lsb
    subwf   val1,F		; dest lsb
    movf    val2+1,W	; msb
    btfss   STATUS,C
    incfsz  val2+1,W	;msb
    subwf   val1+1,F	;dest = dest - source, WITH VALID CARRY
    return		
		

		
		END
		
		
;========== result on terminal VBRAY 19200,8,N,1  ==================		
;with Quartz=10MHz		
;SEC_DELAY=1sec
; with a LM35DZ
19:49:07.479> START
19:49:16.542> 0078 	0044 	0044 	0044 	0044 	0044 	0044 	0044 	0044 	0044 	0474 + 23.7C
19:49:26.556> 0044 	0044 	0044 	0044 	0044 	0044 	0044 	0044 	0044 	0044 	0440 + 22.0C
19:49:36.571> 0044 	0044 	0044 	0044 	0044 	0044 	0044 	0044 	0044 	0044 	0440 + 22.0C
19:49:46.635> 0044 	0044 	0044 	0044 	0044 	0044 	0044 	0044 	0044 	0044 	0440 + 22.0C
19:49:56.650> 0044 	0044 	0044 	0044 	0044 	0044 	0044 	0044 	0044 	0044 	0440 + 22.0C
19:50:06.714> 0044 	0044 	0044 	0044 	0044 	0044 	0044 	0044 	0044 	0044 	0440 + 22.0C
19:50:16.729> 0044 	0044 	0044 	0044 	0044 	0044 	0044 	0044 	0044 	0044 	0440 + 22.0C
19:50:26.743> 0044 	0044 	0044 	0044 	0044 	0044 	0044 	0044 	0044 	0044 	0440 + 22.0C
-----------------------

another Test
with Q=4MHz 19200bauds 
Without change SEC_DELAY
with a potentiometre powered by 5V
13:03:21.691> START
13:03:21.691> 0474 
13:03:24.195> 0474 
13:03:26.699> 0153 
13:03:29.202> 0000 
13:03:31.706> 1022 
13:03:34.209> 1022 



